<?php

namespace App\Delivery\Dhl\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for docTypeRef_ContactInfoType StructType
 * @subpackage Structs
 */
class DocTypeRef_ContactInfoType extends AbstractStructBase
{
    /**
     * The Contact
     * @var \App\Delivery\Dhl\StructType\DocTypeRef_ContactType
     */
    public $Contact;
    /**
     * The Address
     * @var \App\Delivery\Dhl\StructType\DocTypeRef_AddressType
     */
    public $Address;
    /**
     * The RegistrationNumbers
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \App\Delivery\Dhl\StructType\DocTypeRef_RegistrationNumbers
     */
    public $RegistrationNumbers;
    /**
     * The BankDetails
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \App\Delivery\Dhl\StructType\DocTypeRef_BankDetails
     */
    public $BankDetails;
    /**
     * Constructor method for docTypeRef_ContactInfoType
     * @uses DocTypeRef_ContactInfoType::setContact()
     * @uses DocTypeRef_ContactInfoType::setAddress()
     * @uses DocTypeRef_ContactInfoType::setRegistrationNumbers()
     * @uses DocTypeRef_ContactInfoType::setBankDetails()
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_ContactType $contact
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_AddressType $address
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_RegistrationNumbers $registrationNumbers
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_BankDetails $bankDetails
     */
    public function __construct(\App\Delivery\Dhl\StructType\DocTypeRef_ContactType $contact = null, \App\Delivery\Dhl\StructType\DocTypeRef_AddressType $address = null, \App\Delivery\Dhl\StructType\DocTypeRef_RegistrationNumbers $registrationNumbers = null, \App\Delivery\Dhl\StructType\DocTypeRef_BankDetails $bankDetails = null)
    {
        $this
            ->setContact($contact)
            ->setAddress($address)
            ->setRegistrationNumbers($registrationNumbers)
            ->setBankDetails($bankDetails);
    }
    /**
     * Get Contact value
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_ContactType|null
     */
    public function getContact()
    {
        return $this->Contact;
    }
    /**
     * Set Contact value
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_ContactType $contact
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_ContactInfoType
     */
    public function setContact(\App\Delivery\Dhl\StructType\DocTypeRef_ContactType $contact = null)
    {
        $this->Contact = $contact;
        return $this;
    }
    /**
     * Get Address value
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_AddressType|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_AddressType $address
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_ContactInfoType
     */
    public function setAddress(\App\Delivery\Dhl\StructType\DocTypeRef_AddressType $address = null)
    {
        $this->Address = $address;
        return $this;
    }
    /**
     * Get RegistrationNumbers value
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_RegistrationNumbers|null
     */
    public function getRegistrationNumbers()
    {
        return $this->RegistrationNumbers;
    }
    /**
     * Set RegistrationNumbers value
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_RegistrationNumbers $registrationNumbers
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_ContactInfoType
     */
    public function setRegistrationNumbers(\App\Delivery\Dhl\StructType\DocTypeRef_RegistrationNumbers $registrationNumbers = null)
    {
        $this->RegistrationNumbers = $registrationNumbers;
        return $this;
    }
    /**
     * Get BankDetails value
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_BankDetails|null
     */
    public function getBankDetails()
    {
        return $this->BankDetails;
    }
    /**
     * Set BankDetails value
     * @param \App\Delivery\Dhl\StructType\DocTypeRef_BankDetails $bankDetails
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_ContactInfoType
     */
    public function setBankDetails(\App\Delivery\Dhl\StructType\DocTypeRef_BankDetails $bankDetails = null)
    {
        $this->BankDetails = $bankDetails;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Delivery\Dhl\StructType\DocTypeRef_ContactInfoType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
