<?php

namespace App\Delivery\Dhl\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for LabelBarcodes StructType
 * Meta information extracted from the WSDL
 * - documentation: Customer bar code that would like to be printed in supported transport label - ECOM26_84CI_003 templates
 * @subpackage Structs
 */
class LabelBarcodes extends AbstractStructBase
{
    /**
     * The LabelBarcode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \App\Delivery\Dhl\StructType\LabelBarcode
     */
    public $LabelBarcode;
    /**
     * Constructor method for LabelBarcodes
     * @uses LabelBarcodes::setLabelBarcode()
     * @param \App\Delivery\Dhl\StructType\LabelBarcode $labelBarcode
     */
    public function __construct(\App\Delivery\Dhl\StructType\LabelBarcode $labelBarcode = null)
    {
        $this
            ->setLabelBarcode($labelBarcode);
    }
    /**
     * Get LabelBarcode value
     * @return \App\Delivery\Dhl\StructType\LabelBarcode|null
     */
    public function getLabelBarcode()
    {
        return $this->LabelBarcode;
    }
    /**
     * Set LabelBarcode value
     * @param \App\Delivery\Dhl\StructType\LabelBarcode $labelBarcode
     * @return \App\Delivery\Dhl\StructType\LabelBarcodes
     */
    public function setLabelBarcode(\App\Delivery\Dhl\StructType\LabelBarcode $labelBarcode = null)
    {
        $this->LabelBarcode = $labelBarcode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Delivery\Dhl\StructType\LabelBarcodes
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
